local apollonode = require "apolloutility.apollonode"
local deformation = require "facecute.deformation.deformation"
local threesticker = require "facecute.3dsticker.threesticker"
local facesticker2d = require "facecute.facesticker2d.facesticker2d"
local soundeffect = require "facecute.soundeffect.soundeffect"
local facechange = require "facecute.facechange.facechange"
local renderqueue = require "apolloutility.renderqueue"
local apolloengine = require "apolloengine"
local mathfunction = require "mathfunction"
local defined = require "facecute.defined"
local Object = require "classic"
local particle = require "facecute.particle.particle"
local headtarget = require "facecute.headtarget"
local facecropmouth = require "game.facecropmouth"
local show_rect = false;
local point_count = 2*4;

--作为一个独立单元每个识别出来的人头配备一个，这个数据中包含需要管理的3d模型、变形的方法
local headtargetgame = headtarget:extend();
function headtargetgame:new(maincamera)
 headtargetgame.super.new(self,maincamera)
end


--传入数据表，解析数据3d贴纸、2d贴纸、变形器
function headtargetgame:ParseConfig(config, paramters)
  local res = true;
 
  --res = headtargetgame.super.ParseConfig(self,config,paramters);
  if(config.bigmouth)
  then
    --local boundBox = self.head:GetBindBox();
    local obj = facecropmouth();
    res = res and obj:ParseConfig(config.bigmouth);
    --renderqueue:Prev(obj);
    renderqueue:Queue("Sticker",obj);
    --obj:SetRootNode(self.head);
    table.insert(self.assets,obj);
    
  end
  self.isshow = false;  

  
  return res;
end

function headtargetgame:ReleaseResource()
  if self.assets then
    for _, node in ipairs(self.assets) do
      node:Destroy();
    end 
  end
  
  if self.rect then
    self.rect:Destroy();
    self.rect = nil;
  end
  
  if self.head then
    self.head:Destroy();
    self.head = nil;
  end

  --headtargetgame.super.ReleaseResource(self);
end

return headtargetgame;