local vc = require "venuscore";

local textureloader = {}

if _PLATFORM_WINDOWS then
  collectgarbage("setpause",200);
  collectgarbage("setstepmul",3000);
end

function textureloader:Initialize()
  if self.service == nil then
    WARNING("texture loader service setup ")
    self.service = vc.IServicesSystem:Create("apolloutility.asynctexture.textureloadservice");
    WARNING("texture loader service done ")
  end
end

function textureloader:CreateTexture(agent, index, picoder, channelindex, path, premul, keep)
  self.service:CreateTexture(agent, index, picoder, channelindex, path, premul or false, keep or false)
end

function textureloader:Wait()
  return self.service ~= nil and self.service:Wait()
end

function textureloader:Clear()
  return self.service ~= nil and self.service:Clear()
end

return textureloader;
