local defined = {
  typeid = {
    eyescale = 1, -- warp level 0~220 大眼
    faceshin = 2, -- warp level 0~140 瘦脸
    noseshin = 3, -- warp level 0~100 瘦鼻
    mouthscale = 4, -- warp level -50~50 嘴型
    lipscale = 5, -- warp level 0~100 丰唇
    chinscale = 6, -- warp level 0~100 下巴
    philtrumscale = 7, -- warp level 0~100 人中
    eyebrow = 8, -- warp level 0~100 挑眉
    noselength = 9, -- warp level 0~100 长鼻
    innercanthus = 10, -- warp level 0~100 内眼角
    outercanthus = 11, -- warp level 0~100 外眼角
    eyeangle = 12, -- warp level 0~100 眼睛角度
    eyedist = 13, -- warp level -50~50 眼距
    hairline = 14, -- warp level 0~100 发际线
    roundeye = 15 -- warp level 0~100 圆眼
    },
  face_start = 1,
  nose_start = 17,
  chin_start = 19,
  HairLine_start = 24,
  Philtrum_start = 29,
  Noselength_start = 31,
  InnerCanthus_start = 37,
  Eyebrow_start = 39,
  OuterCanthus_start = 41,
  EyeAngDis_start = 45,
  FaceSingleNum = 2,

  -- top down left right
  RightEyeCornerIndices = {75, 76, 58, 61},
  LeftEyeCornerIndices = {72, 73, 55, 52},

  --0~15点(32~17点)，82点(83点)，16点，49点 左右对称
  -- last four: eye corner, mouth corner, mouth top and bottom, chin
  --索引从0开始
  FaceKey = {
    {0,32}, {1,31}, {2,30}, {3, 29},
    {5,27}, {7,25}, {10,22}, {12,20}, {14,18},
    {84,90}, {87,93}, {82, 83},
    {49, 49}, {16, 16}
  },
  --- 0 to use fall_off[1], 1 to use fall_off[2]
  FaceKeyMask={
    1, 1, 1, 1,
    1, 1, 0, 0, 0,
    1, 1, 1,
    1, 0
  },
  --索引从0开始
  FaceDir = {
    {2,30}, {1,31}, {1,31}, {2, 30},
    {0,32}, {2,30}, {2,30}, {2,30}, {3,29},
    {55,58}, {43,43}, {55, 58},
    {43, 43}, {43, 43}
  },
  
  NumFaceAddition = 2,
  DeltaFaceAddition = 3,

  NoseIndices = {{78, 79}, {82, 83}},

  -- top down left right
  MouthIndices = {87, 93, 84, 90},
  MouthRadius = {1.1, 0.8},
  MouthScale = {-0.2, -0.2},

  -- Noselength points definition
  NoselengthKey = {{80,81}, {82,83}, {48, 50}, 49, 46, 45},
  NoselengthDir = 43,

  MouthUpIndices = {85, 86, 87, 88, 89},
  MouthDownIndices = {91, 92, 93, 94, 95},
  MouthInnerIndices = {96, 97, 98, 99, 100, 101, 102, 103},
  MouthUpOuterMid = 87,
  MouthUpInnerMid = 98,
  -- MouthTriangles = {0, 2, 4, 0, 4, 3, 4, 2, 1, 4, 1, 3},
  MouthTriangles = {
    10, 2, 3, 20, 22, 21, 15, 17, 13, 
    18, 1, 19, 10, 3, 12, 14, 4, 16, 
    22, 20, 7, 16, 4, 5, 24, 27, 25, 
    6, 20, 1, 22, 23, 21, 8, 22, 7, 
    23, 22, 24, 8, 26, 24, 28, 29, 26, 
    27, 26, 29, 8, 9, 26, 9, 2, 28, 
    29, 28, 0, 0, 28, 2, 11, 0, 10, 
    11, 10, 12, 0, 2, 10, 26, 9, 28, 
    3, 2, 9, 11, 12, 13, 3, 9, 8, 
    12, 14, 15, 12, 3, 4, 12, 15, 13, 
    14, 16, 15, 16, 17, 15, 16, 5, 18, 
    16, 18, 19, 5, 6, 18, 16, 19, 17, 
    18, 6, 1, 7, 20, 6, 7, 5, 8, 
    14, 12, 4, 5, 7, 6, 5, 4, 8, 
    27, 24, 26, 25, 23, 24, 3, 8, 4, 
    24, 22, 8, 20, 21, 1
  },
  
  ChinKey = {
    {7, 25}, {10, 22}, {12, 20}, {14, 18}, {16, 16}
  },
  --索引从0开始
  ChinDir = {
    {43,43}, {43,43}, {43,43}, {43,43}, {43,43}
  },
  
  PhiltrumKey = {{48, 50}, {86, 88}},
  PhiltrumDir = {{88, 86}, {50, 48}},

  EyeTriangles={
    0,4,6,4,8,6,6,8,10,8,12,10,12,14,10,12,2,14,
    1,5,0,5,4,0,5,9,4,9,8,4,9,12,8,9,13,12,13,3,2,13,2,12,
    1,0,7,0,6,7,6,10,7,10,11,7,10,14,11,14,15,11,14,2,15,2,3,15
  },
  RightEyeKeyPoints={52,53,72,54,55,57,73,56},
  LeftEyeKeyPoints={61,60,75,59,58,62,76,63},

  -- hair line indices
  HairlineIndices = {{109, 125}, {112, 122}, {114, 120}, {116, 118}, {117, 117}},
  HairlineDir = {{78, 79}, {78, 79}, {78, 79}, {78, 79}, {43, 43}},

  -- innercanthus points definition
  InnercanthusKey = {{55,78}, {58,79}},
  InnercanthusDir = {64,71},
  -- InnercanthusDir = 44,

  -- outercanthus points definition
  OutercanthusKey = {{52, 61}, {57, 62}},
  OutercanthusDir = {{72, 75}, {72, 75}},
  OutercanthusEyeRef = {{53, 60}, {52, 61}},
  
  EyebrowKey = {{34, 41}, {35, 40}},
  EyebrowDir = {{82, 83}, {82, 83}},
  
  -- lmk warp defined --
  FaceKeyScript = {{0, 32}, {1, 31}, {2, 30}, {3, 29}, {5, 27}, {7, 25},
    {10, 22},{12, 20}, {14, 18},  {16, 16}},
  FaceDirScript = {{2, 30}, {1,31}, {1,31}, {2, 30}, {0, 32},  {2, 30}, 
    {2, 30}, {2, 30}, {3, 29},  {43, 43}},

  FaceParamRadiusScript = {0.304, 0.189, 0.227, 0.141, 0.365, 
    0.28, 0.266, 0.283, 0.3, 0.24},
  FaceParamScript = {{0.006, 0}, {0.001, 0}, {0.003, 0.004}, {0.007, 0.002}, {0.006, 0.003}, {0.024, 0.002}, 
    {0.016, 0.017}, {0.013, 0.02}, {0.013, 0.03}, {0, 0.03}},
  FaceScaleScript = {1.4, 8, 4, 2, 3.2, 1.5, 1.8, 2, 2.4, 1.2},

  FaceWarpMap = {
    {84, 8}, {96, 8}, {95, 12}, {94, 14}, {93, 16}, {92, 18}, {91, 20}, {90, 24}, {100, 24},
    {33, 1}, {34, 1}, {64, 1}, {41, 31}, {42, 31}, {71, 31},
    {80, 5}, {82, 5}, {47, 5}, {81, 27}, {83, 27}, {51, 27}},
  FaceWarpCoef = {
    0.3, 0.3, 0.5, 0.5, 0.5, 0.5, 0.5, 0.3, 0.3, 
    0.5, 0.4, 0.3, 0.4, 0.5, 0.3,
    0.4, 0.5, 0.4, 0.4, 0.5, 0.4},
    
  AdvFaceWarpMap = {{70, 8}, {71, 8}, {72, 8}, {87, 8}, {88, 8}, {89, 8}, {84, 24}, {85, 24}, {86, 24}, {101, 24}, {102, 24}, {103, 24},
    {119, 9}, {120, 10}, {121, 11}, {122, 12}, {123, 13}, {124, 14}, {125, 15}, {126, 16}, {127, 17}, {128, 18}, {129, 19}, {130, 20}, {131, 21}, {132, 22}, {133, 23},
    {104, 9}, {105, 10}, {106, 11}, {107, 12}, {108, 13}, {109, 14}, {110, 15}, {111, 16}, {112, 17}, {113, 18}, {114, 19}, {115, 20}, {116, 21}, {117, 22}, {118, 23},
    {44, 1}, {45, 1}, {46, 1}, {51, 1}, {52, 1}, {57, 31}, {58, 31}, {59, 31}, {64, 31}, {65, 31}},
  AdvFaceWarpCoef = {0.5, 0.5, 0.3, 0.4, 0.3, 0.3, 0.3, 0.5, 0.5, 0.3, 0.4, 0.3, 
    0.4, 0.3, 0.3, 0.2, 0.2, 0.2, 0.2, 0.2, 0.2, 0.2, 0.2, 0.2, 0.3, 0.3, 0.4,
    0.4, 0.4, 0.3, 0.3, 0.2, 0.2, 0.2, 0.2, 0.2, 0.2, 0.2, 0.3, 0.3, 0.4, 0.4,
    0.5, 0.4, 0.3, 0.4, 0.3, 0.5, 0.4, 0.3, 0.4, 0.3},
  
  FaceForeheadWarp = {{22, 1}, {21, 1}, {20, 1}, {19, 1}, {18, 1}, {17, 1}, {16, 1},
    {0, 31}, {1, 31}, {2, 31}, {3, 31}, {4, 31}, {5, 31}, {6, 31}},
  FaceForeheadCoef = {0.6, 0.7, 0.7, 0.6, 0.4, 0.3, 0.2, 
    0.6, 0.7, 0.7, 0.6, 0.4, 0.3, 0.2},
  
  NoseWarpMap = {{47, 82}, {48, 82}, {50, 83}, {51, 83}, {80, 82}, {81, 83}},
  NoseWarpCoef = {0.7, 0.4, 0.4, 0.7, 0.7, 0.7},
  
  ChinParamScript = {{0, 0.03}, {0, 0.01}, {0, 0.013}, {0, 0.019}, {0, 0.023}},
  ChinParamRadiusScript = {0.17, 0.1, 0.38, 0.16, 0.23},
  ChinScaleScript = {1, 1, 1, 1, 1},
  
  ForeheadParamScript = {{0.0, 0.05}, {0.0, 0.05}, {0.0, 0.05}, {0.0, 0.05}, {0.0, 0.05}},
  ForeheadParamRadiusScript = {0.3, 0.3, 0.3, 0.3, 0.3},
  ForeheadScaleScript = {1, 1.5, 1.5, 1.5, 1.5},
  
  AdvPhiltrumWarpMap = {{74, 86}, {75, 86}, {76, 86}, {77, 86}, {78, 87}, {79, 88}, {80, 88}, {81, 88}, {82, 88}},
  AdvPhiltrumWarpCoef = {0.5, 0.9, 1, 1, 1, 1, 1, 0.9, 0.5},
  
  NoseLengthParamScript = {{0.000, 0.030}, {0.000, 0.030}, {0.000, 0.030}, {0.000, 0.030}, {0.000, 0.02}, {0.000, 0.030}},
  NoseLengthParamRadiusScript = {0.54, 0.54, 0.1, 0.3, 0, 0.8},
  NoseLengthWarpMap = {{47, 48}, {51, 50}},
  NoseLengthWarpCoef = {1, 1},
  
  AdvInnercanthusWarpMap = {{8, 55}, {9, 55}, {10, 55}, {20, 55}, {21, 55}, {30, 58}, {31, 58}, {32, 58}, {43, 58}, {42, 58}},
  AdvInnercanthusWarpCoef = {1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
  
  AdvOutercanthusWarpMap = {{11, 52}, {0, 57}, {1, 57}, {2, 57}, {3, 57}, {4, 57}, {5, 57},
    {33, 61}, {22, 62}, {23, 62}, {24, 62}, {25, 62}, {26, 62}, {27, 62}},
  AdvOutercanthusWarpCoef = {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
  
  EyebrowParamScript = {{-0.012,0.039},{-0.033,0.023}},
  EyebrowParamRadiusScript = {0.208, 0.287},

  EyebrowWarpMap = {{64, 34}, {36, 35}, {65, 35}, {66, 35}, {39, 40}, {69, 40}, {70, 40}, {71, 41}},
  EyebrowWarpCoef = {1, 0.8, 1, 0.4, 0.8, 0.4, 1, 1},
  AdvEyebrowWarpMap = {{46, 34}, {45, 34}, {51, 34}, {52, 34}, {47, 35}, {48, 35}, {49, 35}, {53, 35}, {54, 35}, {55, 35},
    {58, 41}, {59, 41}, {64, 41}, {65, 41}, {60, 40}, {61, 40}, {62, 40}, {66, 40}, {67, 40}, {68, 40}},
  AdvEyebrowWarpCoef = {1.2, 1, 0.8, 1, 1, 0.8, 0.4, 1, 0.8, 0.2, 
    1, 1.2, 0.8, 1, 1, 0.8, 0.4, 1, 0.8, 0.2}
}

return defined