local defined = {
    confidence_threshold = 0.7,
    confidence_regions = {
        eye_region = {
            keys = {"left_eye_lmk", "right_eye_lmk"},
            all_low_transit = {
                blendshape = {
                    "browDown_R","browOuterUp_R","eyeBlink_R","eyeLookDown_R","eyeLookIn_R",
                    "eyeLookOut_R","eyeLookUp_R","eyeSquint_R","eyeWide_R",
                    "browDown_L","browOuterUp_L","eyeBlink_L","eyeLookDown_L","eyeLookIn_L",
                    "eyeLookOut_L","eyeLookUp_L","eyeSquint_L","eyeWide_L",
                    "browInnerUp"
                },
                time = 0.5
            },
            one_low_copy = {
                ["left_eye_lmk"] = {
                    ["browDown_R"] = "browDown_L",
                    ["browOuterUp_R"] = "browOuterUp_L",
                    ["eyeBlink_R"] = "eyeBlink_L",
                    ["eyeLookDown_R"] = "eyeLookDown_L",
                    ["eyeLookIn_R"] = "eyeLookIn_L",
                    ["eyeLookOut_R"] = "eyeLookOut_L",
                    ["eyeLookUp_R"] = "eyeLookUp_L",
                    ["eyeSquint_R"] = "eyeSquint_L",
                    ["eyeWide_R"] = "eyeWide_L"
                },
                ["right_eye_lmk"] = {
                    ["browDown_L"] = "browDown_R",
                    ["browOuterUp_L"] = "browOuterUp_R",
                    ["eyeBlink_L"] = "eyeBlink_R",
                    ["eyeLookDown_L"] = "eyeLookDown_R",
                    ["eyeLookIn_L"] = "eyeLookIn_R",
                    ["eyeLookOut_L"] = "eyeLookOut_R",
                    ["eyeLookUp_L"] = "eyeLookUp_R",
                    ["eyeSquint_L"] = "eyeSquint_R",
                    ["eyeWide_L"] = "eyeWide_R"
                }
            }
        },
        mouth_region = {
            keys = {"mouth_lmk"},
            all_low_transit = {
                blendshape = {
                    "jawForward","jawLeft","jawOpen","jawOpenMouthClose","jawRight",
                    "mouthSmile_L","mouthSmile_R","mouthDimple_L","mouthDimple_R","mouthFrown_L",
                    "mouthFrown_R","mouthFunnel","mouthLeft","mouthLowerDown_L","mouthLowerDown_R",
                    "mouthPucker","mouthRight","mouthRollLower","mouthRollUpper","mouthShrugLower",
                    "mouthShrugUpper","mouthTightener","mouthUpperUp_L","mouthUpperUp_R",
                    "noseSneer_L","noseSneer_R","cheekPuff"
                },
                time = 0.5
            }
        }
    }
}

return defined