local Object = require "classic"

local FrameTimer = Object:extend()

function FrameTimer:new(time)
  self:ResetTime(time)
end

function FrameTimer:ResetTime(time)
  self.total_time = time
  self.remaining_time = 0
end

function FrameTimer:GetTime()
  return self.total_time
end

function FrameTimer:Start()
  self.remaining_time = self.total_time
end

function FrameTimer:Finished()
  return self.remaining_time == 0
end

function FrameTimer:Progress()
  return 1 - self.remaining_time / self.total_time
end

function FrameTimer:Update(timespan)
  if self:Finished() then
    return
  end
  self.remaining_time = self.remaining_time - timespan
  if self.remaining_time < 0 then
    self.remaining_time = 0
  end
end

return FrameTimer