local Venuscore = require "venuscore"
local Apolloengine = require "apolloengine"
local Defined = require "apolloutility.defiend"
local HeadBehavior = Venuscore.VenusBehavior:extend("HeadBehavior"); 
local Venusjson = require "venusjson"
local Mathfunction = require "mathfunction"
local Libmasque = require "libmasque"
--[[
local bonesNames = {};

table.insert( bonesNames, "Spine1" );
table.insert( bonesNames, "Spine2" );
table.insert( bonesNames, "Spine3" );
table.insert( bonesNames, "Neck1" );
table.insert( bonesNames, "Neck2" );
table.insert( bonesNames, "Head" );
]]

function HeadBehavior:new()
--[[
    self.Spine1 = nil;
    self.Spine2 = nil;
    self.Spine3 = nil;
    self.Neck1 = nil;
    self.Neck2 = nil;
    self.Head    = nil;  
  ]]  
    self.HeadConfig = ""
    self.Tracking = nil;
end

function  HeadBehavior:_OnAwake()
  self:LoadConfig()
  self:Init()
end

function HeadBehavior:Init()
  if not self.Node or not self.bonesNames then
    return
  end
  --[[
  self.BoneNodes = 
  {
      ["Spine1"] = self.Spine1,
      ["Spine2"] = self.Spine2,
      ["Spine3"] = self.Spine3,
      ["Neck1"] = self.Neck1,
      ["Neck2"] = self.Neck2,
      ["Head"] = self.Head,
  }

  self.BoneNames = {
    self.Spine1.Name,
    self.Spine2.Name,   
    self.Spine3.Name,  
    self.Neck1.Name,
    self.Neck2.Name,
    self.Head.Name,        
  }
  ]]
  self.BoneTrans = {};
  --self.BoneTRot = {};
  for i = 1, #self.bonesNames do
    local node = self.Node:GetRoot():GetNodeByName(self.bonesNames[i]);
    if node then
      local trans = node:GetComponent(Apolloengine.Node.CT_TRANSFORM);
      table.insert(self.BoneTrans, trans);
      --[[
      table.insert(self.BoneTRot, 
        --trans:GetLocalRotation()
        Mathfunction.Quaternion()
        );
        ]]
    end
  end
    

end

function HeadBehavior:LoadConfig()
  if self.HeadConfig == "" then
    return
  end
  local file = Venusjson.LaodJsonFile(self.HeadConfig);
  if file ~=nil then
    self.bonesNames = file.nodes;
    self.bonesWeight = file.weight;
  end
end

function HeadBehavior:_OnUpdate(delta)
  if self.bonesNames == nil or #self.bonesNames == 0 then 
    return;
  end
  if self.Tracking then
    --目前只对T-pos无local旋转的骨骼适用
    -- local rotmat = self.Tracking:GetBilinearTracking():GetRotation();
    -- local headRot = rotmat:ToQuaternion();
    local headRot = self.Tracking:GetTrackingRotation();
    local num = #self.bonesNames;
    local deltaRot = headRot;
    for i = 1, num do
      local rot = Mathfunction.Mathutility:Slerp(Mathfunction.Quaternion(), deltaRot, self.bonesWeight[i] );
      self.BoneTrans[i]:SetLocalRotation(rot);
    end
  end

end

--[[
for i=1, #bonesNames do
  HeadBehavior:MemberRegister(bonesNames[i],
    Venuscore.ScriptTypes.ReferenceType(
    Apolloengine.Node:RTTI()
  )); 
end
]]
HeadBehavior:MemberRegister("HeadConfig",  
  Venuscore.ScriptTypes.FilePathType(
    {"json"},
    nil,
    function(this, value)
        this.HeadConfig = value
        this:LoadConfig()
        this:Init()
    end
))

HeadBehavior:MemberRegister(
  "Tracking",
  Venuscore.ScriptTypes.ReferenceType(
    Libmasque.TrackingComponent:RTTI()
  )
)

return HeadBehavior;