local MaskSequence = require "biugo.mask_sequence_mobile"
local biugodefined = require "biugo.defined"
local Liveportrait = require "biugo.liveportrait"

local Object = require "classic"



local LiveportraitSequence = MaskSequence:extend();

function LiveportraitSequence:new(customID,channel, isText, materialName, alphaMode, splitInfo, renderorder, start_time, last_time, anim_path, fboSize)
  LiveportraitSequence.super.new(self,customID,channel, isText, materialName, alphaMode, splitInfo, renderorder);
  self.livePortrait = Liveportrait(start_time, last_time, anim_path, fboSize);
  self.custom_texture = nil;
end

--重载取图片的函数
function LiveportraitSequence:GetCustomTexture()
  
  --变脸只需要取一次图
  if self.custom_texture == nil then
    local custom_texture = self.livePortrait:GetPortraitTex();
    self.custom_texture = custom_texture;
    self.custom_texture_size = custom_texture:GetSize();
    self:SetShow(true);
  end
  

end

function LiveportraitSequence:Update(timespan)
  
  self.livePortrait:Update(timespan);

  LiveportraitSequence.super.Update(self,timespan);
end


function LiveportraitSequence:Clear()
  LiveportraitSequence.super.Clear(self);
  if self.livePortrait then
    self.livePortrait:Clear();
  end
end

function LiveportraitSequence:UpdateMuglifeMaterial()
  self.livePortrait:UpdateMuglifeMaterial();
end

return LiveportraitSequence;
