local BundleSystem = require "venuscore.bundle.bundlesystem"
local renderqueue = require "apolloutility.renderqueue"
local apollonode = require "apolloutility.apollonode"
local defined = require "apolloutility.defiend"
local apolloengine = require "apollocore"
local venuscore = require "venuscore"
local editorscene = require "editorscene"
local apolloDefine = require "apolloutility.defiend"

local backgroundmanager = {};

function backgroundmanager:Initialize(layer,resourceType)
    self.scene = nil;
    self.baseobjects = nil;
    self.InputTex = nil;
    self.layer = layer;
    self.resourceType = resourceType;

    

    --self.backgroundCamera = nil;
end

function backgroundmanager:LoadConfig(path,rootconfig)
    if rootconfig.scene then

        if self.scene ~= nil then 
            self:ReleaseResource();
        end

        
        self.InputTex = renderqueue:GetTexture(self.layer);
        apolloengine.IResourceSystem:ResourcekeyRedirect(
            defined.LAST_QUEUE_TEXTURE, 
            defined.LAST_QUEUE_TEXTURE_BACKGROUND);
        apolloengine.DeviceResource:PushDeviceResource(
            defined.LAST_QUEUE_TEXTURE_BACKGROUND,
            self.InputTex);

    
        local pathDir= string.match(path, "(.+)/[^/]*%.%w+$");
        local rootdir = pathDir.."/"; 
        venuscore.IFileSystem:SetResourcePath(rootdir);
        --local scene = apolloengine.SceneManager:GetOrCreateScene(apolloDefine.default_scene_name);

        local baseobject = self:CreateInstanceFromBundle(
        venuscore.IFileSystem:PathAssembly(rootconfig.scene));

        local newscene = editorscene(self.layer,self.resourceType);
        newscene:LoadConfig(baseobject);
        self.scene = {["index"] = newscene.index,["scene"] = newscene};
        self.baseobjects = {["index"] = newscene.index,["baseobject"] = baseobject};

    return true;
    end

    return false;
end


function backgroundmanager:CreateInstanceFromBundle(path)
  local bundlepath = venuscore.IFileSystem:PathAssembly(path);
  local scene = apolloengine.SceneManager:GetOrCreateScene(apolloDefine.default_scene_name);
  local _,deSerializeRes = BundleSystem:DeserializeFromPath(bundlepath,BundleSystem.DeserializeMode.Prefab,scene);
  return deSerializeRes
end

function backgroundmanager:Update(def)
  self.scene["scene"]:UpdateWithOutPhysic(def) 
end

function backgroundmanager:ReleaseResource()
    if self.scene ~= nil then
        self.baseobjects = nil;
        self.scene["scene"]:ReleaseResource();
        self.scene = nil;
        return true;
    end

    return false;
end

return backgroundmanager;