local renderqueue = require "apolloutility.renderqueue"
local apollonode = require "apolloutility.apollonode"
local defined = require "apolloutility.defiend"
local mathfunction = require "mathfunction"
local apolloengine = require "apollocore"
local venuscore = require "venuscore"
local venusjson = require "venusjson"
local apollocore = require "apollocore"
local apolloDefine = require "apolloutility.defiend"
local Sticker = require "editorscene.stickerscene"
local VRScene = require "editorscene.vrscene"
local colorspaceconverter = require "colorspaceconverter"

--renderqueue中的layer名称和对应scene的渲染顺序
local LAYER_FACE_BEAUTY = "FaceBeautify"
local LAYER_EDITOR_MAKE_UP   = "EditorMakeUp"
local LAYER_STYLISH = "Stylish"
local LAYER_STICKER = "Sticker"

local LAYER_FACEBUAUTY_SEQUENCE = -300
local LAYER_MAKEUP_SEQUENCE = -200
local LAYER_STYLISH_SEQUENCE = -100
local LAYER_STICKER_SEQUENCE = 100  --scene的渲染


local SCENE_TYPE_VR = "VirtualScene"
local SCENE_TYPE_VR_SEQUENCE = 100

--编辑器素材统一加载接口
local SceneLoader = {}

--param: preLayer      贴纸上一层的标记
function SceneLoader:Initialize()
  self.sceneList = {};
  self.InputTex = nil;

  -- self.converter = colorspaceconverter.new();
  -- local viewSize = apolloengine.Framework:GetResolution();
  -- -- create converter from default scene
  -- local isSRGB2Linear = true;
  -- local LayerMask = "sceneLoaderGTL";
  -- self.converter:Initialize_sRGB_Transfer(nil, isSRGB2Linear, mathfunction.vector2(viewSize:x(), viewSize:y()), LayerMask);
  -- self.converter:Deactivate();

  self.BackgroundUtil = {};
  self.BackgroundUtil.InputTex = nil;
  -- self.BackgroundUtil.converter = colorspaceconverter.new();
  -- self.BackgroundUtil.converter:Initialize_sRGB_Transfer(nil, isSRGB2Linear, mathfunction.vector2(viewSize:x(), viewSize:y()), "BackgroundGTL");
  -- self.BackgroundUtil.converter:Deactivate();
  self.loadSticker = false;
end

function SceneLoader:Update(spantime)
  self:UpdateFacebeauty(spantime);
  self:UpdateMakeup(spantime);
  self:UpdateStylish(spantime);
  self:UpdateSticker(spantime);
end

function SceneLoader:OnRecordStart()
end

--一次卸载所有素材
function SceneLoader:ReleaseAllResource()
  self:ReleaseSticker();
  -- self.converter:Delete_sRGB_Transfer();
  -- self.BackgroundUtil.converter:Delete_sRGB_Transfer();
end


-------------------------------------------------------贴纸-----------------------------------------------------------------
--当贴纸加载
function SceneLoader:LoadAsSticker(path)
  --只能加载一个贴纸
  if self.sceneList[LAYER_STICKER] then
    self:ReleaseSticker();
  end
  
  local rootConfig = venusjson.LaodJsonFile(path);
  if rootConfig and rootConfig.scene then
    renderqueue:Activate(LAYER_STICKER);

    -- set global color space settings before loading resources.
    local AdvancedShadingSetting = false;
    if rootConfig.AdvancedShading == true then
          AdvancedShadingSetting = true;
    end
    apollocore.Framework:SetEditorAdvancedShading(AdvancedShadingSetting);
    
    if renderqueue:Initialized() then
      self.InputTex = renderqueue:GetTexture(LAYER_STICKER);
      -- self.converter:SetCamTexEntity(self.InputTex);
      apollocore.IResourceSystem:ResourcekeyRedirect(
        defined.LAST_QUEUE_TEXTURE, 
        defined.LAST_QUEUE_TEXTURE_STICKER);

      -- if AdvancedShadingSetting == true then
      --   self.converter:Activate();
      --   apolloengine.DeviceResource:PushDeviceResource(
      --     defined.LAST_QUEUE_TEXTURE_STICKER,
      --     self.converter.sRGB_Transfer.texture);
      -- else
      --   self.converter:Deactivate();
        apolloengine.DeviceResource:PushDeviceResource(
          defined.LAST_QUEUE_TEXTURE_STICKER,
          self.InputTex);
      -- end
    end
    
    --设置ress路径
    local pathDir= string.match(path, "(.+)/[^/]*%.%w+$");
    local rootdir = pathDir.."/";
    venuscore.IFileSystem:SetResourcePath(rootdir);

    

    local Sticker = Sticker(LAYER_STICKER_SEQUENCE,LAYER_STICKER);
    Sticker.AdvancedShading = AdvancedShadingSetting; 
    Sticker:LoadConfig(rootConfig.scene);
    self.sceneList[LAYER_STICKER] = Sticker;
    self.loadSticker = true;
  end
  return true;
end




function SceneLoader:UpdateSticker(spantime)
  local Sticker = self.sceneList[LAYER_STICKER];
  if Sticker then
     --返回coms数组，虚拟主播将挂接放在渲染后的临时解决方案，最小化影响范围，不对历史贴纸产生影响
    Sticker:Update(spantime);
  end
end

function SceneLoader:AfterRenderSticker(spantime)
  local Sticker = self.sceneList[LAYER_STICKER];
  if Sticker then
     --返回coms数组，虚拟主播将挂接放在渲染后的临时解决方案，最小化影响范围，不对历史贴纸产生影响
    Sticker:AfterRender(spantime);
  end
end


--卸载贴纸
function SceneLoader:ReleaseSticker()
  local Sticker = self.sceneList[LAYER_STICKER];
  if Sticker then
    self.loadSticker = false;
    Sticker:ReleaseResource();

    -- recover global color space setting
    if Sticker.AdvancedShading == true then
      if renderqueue:Initialized() then
        apolloengine.DeviceResource:PushDeviceResource(
          defined.LAST_QUEUE_TEXTURE_STICKER,
          self.InputTex);
      end
      apollocore.Framework:SetEditorAdvancedShading(false);
    end
  end
  self.sceneList[LAYER_STICKER] = nil;
  return true;
end



function SceneLoader:OnRecordStartSticker()
end

function SceneLoader:OnRecordStopSticker()
end

-----------------------------------------------------------------------人偶-----------------------------------------------------------------




-----------------------------------------------------------------------美妆-----------------------------------------------------------------
--param: path  素材路径
--param: makeupType  美妆类型
function SceneLoader:LoadAsMakeup(path,makeupType)
end

function SceneLoader:UpdateMakeup(spantime)
end

--param: makeupType  美妆类型
function SceneLoader:ReleaseMakeup(makeupType)
end

function SceneLoader:OnRecordStartMakeup()
end

function SceneLoader:OnRecordStopMakeup()
end






--------------------------------------------------------------美颜-----------------------------------------------------------------------
function SceneLoader:UpdateFacebeauty(spantime)
end

function SceneLoader:ReleaseFacebeauty()
end

function SceneLoader:OnRecordStartFacebeauty()
end

function SceneLoader:OnRecordStopFacebeauty()
end



--------------------------------------------------------------风格滤镜-----------------------------------------------------------------------
function SceneLoader:UpdateStylish(spantime)
end

function SceneLoader:ReleaseStylish()
end

function SceneLoader:OnRecordStartStylish()
end

function SceneLoader:OnRecordStartStylish()
end


--------------------------------------------------------------VR 场景-----------------------------------------------------------------------
function SceneLoader:LoadVRScene(path)

  if self.sceneList[SCENE_TYPE_VR] then
    self:ReleaseVRScene();
  end

  local rootConfig = venusjson.LaodJsonFile(path);
  if rootConfig.scene then
    
    apollocore.Framework:SetCurrentAdvancedShading(false);

    
    --设置ress路径
    local pathDir= string.match(path, "(.+)/[^/]*%.%w+$");
    local rootdir = pathDir.."/";
    venuscore.IFileSystem:SetResourcePath(rootdir);

    
    local VirtualScene = VRScene(SCENE_TYPE_VR_SEQUENCE,SCENE_TYPE_VR);
    VirtualScene.AdvancedShading = false;
    VirtualScene:LoadConfig(rootConfig.scene);
    self.sceneList[SCENE_TYPE_VR] = VirtualScene;
  end

  return true;
end

function SceneLoader:UpdateVRScene(spantime)
  local VirtualScene = self.sceneList[SCENE_TYPE_VR];
  if VirtualScene then  
    VirtualScene:Update(spantime);
  end
end

function SceneLoader:ReleaseVRScene(path)
  local VirtualScene = self.sceneList[SCENE_TYPE_VR];
  if VirtualScene then   
    VirtualScene:ReleaseResource();
  end
  self.sceneList[SCENE_TYPE_VR] = nil;
  return true;
end


------------------------------------------------------------ 通用 --------------------------------------------------------------------
function SceneLoader:EnableScenes(enable)
  for type, baseScene in pairs(self.sceneList) do
    WARNING("EnableScenes type = "..tostring(type));
    baseScene:EnableScene(enable);
  end
end


return SceneLoader;

