local venuscore = require "venuscore"
local renderqueue = require "apolloutility.renderqueue"
local apolloengine = require "apollocore"
local BaseScene = require "editorscene.basescene"
local ProfileScope = venuscore.ProfileScope

local VRScene = BaseScene:extend();

local PhysicsFreq = 150;

-- VR scene is singlely loaded, not inserted into renderqueue

function VRScene:new(sceneSequence,insertLayer)
  VRScene.super.new(self,sceneSequence,insertLayer);

  self.leftEyeOutputCamera = {};  -- left eye camera with no RT in editor in VR Mode
  self.rightEyeOutputCamera = {}; -- right eye camera with no RT in editor in VR Mode
end


function VRScene:_SetupNode(node)
  -- if node then
  --   local vrCamComponent = node:GetComponent(apolloengine.Node.CT_VR_CAMERA);
  --   if vrCamComponent then

  --     local leftEyeCamera = vrCamComponent.LeftEyeCamera;
  --     if leftEyeCamera then
  --       leftEyeCamera:SetSequenceCulling(false);
  --       if leftEyeCamera:GetAttachedRenderTarget() == nil then
  --         table.insert(self.leftEyeOutputCamera,leftEyeCamera);
  --       end
  --     end

  --     local rightEyeCamera = vrCamComponent.RightEyeCamera;
  --     if rightEyeCamera then
  --       rightEyeCamera:SetSequenceCulling(false);
  --       if rightEyeCamera:GetAttachedRenderTarget() == nil then
  --         table.insert(self.rightEyeOutputCamera,rightEyeCamera);
  --       end
  --     end
  --   end

  -- end

  -- local subNodes = node:GetChildrens();
  --   for k,v in pairs(subNodes) do
  --       self:_SetupNode(v);
  -- end
end

-- overwrite
-- there is no upstream texture needs to be blit into VR scene currently 
function VRScene:_CreateInternalNode(scene)
end


-- overwrite
function VRScene:_LinkToRenderQueue()
  
  -- local leftEyeRT = renderqueue:GetLeftEyeOutRenderTarget();
  -- local rightEyeRT = renderqueue:GetRightEyeOutRenderTarget();

  -- if leftEyeRT then
  --   for i = 1, #self.leftEyeOutputCamera do
  --     local cam = self.leftEyeOutputCamera[i];
  --     cam:AttachRenderTarget(leftEyeRT);
  --   end
  -- end

  -- if rightEyeRT then
  --   for i = 1, #self.rightEyeOutputCamera do
  --     local cam = self.rightEyeOutputCamera[i];
  --     cam:AttachRenderTarget(rightEyeRT);
  --   end
  -- end

end


function VRScene:ReleaseResource()
    VRScene.super:ReleaseResource();
    self.leftEyeOutputCamera = {};
    self.rightEyeOutputCamera = {};
end


VRScene._LinkToRenderQueue                     = ProfileScope(VRScene._LinkToRenderQueue,                              "Lua#VRScene._LinkToRenderQueue ")

return VRScene;
