﻿
local apolloDefine = require "apolloutility.defiend"
apolloDefine.default_scene_name = "test"

local renderqueue = require "apolloutility.renderqueue"
local pbrlighting = require "apolloutility.pbrlighting"
local scenetimerender = require "apolloutility.scenetimerender"
local emptyimage = require "apolloutility.emptyimage"
local venuscore = require "venuscore"
local apolloengine = require "apolloengine"
local apollocore = require "apollocore"
local apollonode = require "apolloutility.apollonode"
local mathfunction = require "mathfunction"
local renderqueue = require "apolloutility.renderqueue"
local SceneLoader = require "editorscene.sceneloader"

local TAG = "test"

local LAYER_FACE_BEAUTY = "FaceBeautify"
local LAYER_EDITOR_MAKE_UP   = "EditorMakeUp"
local LAYER_MAKE_UP = "MakeUp"
local LAYER_FACE_LIFT = "FaceLift"
local LAYER_SHARPEN = "Sharpen"
local LAYER_STYLISH = "Stylish"
local LAYER_STICKER = "Sticker"
local LAYER_LAST = "Output"

local apollonode = require "apolloutility.apollonode"

--暂时关闭JIT防止JIT失败导致的效率下降
if _PLATFORM_ANDROID or _PROFILER then
    jit.off();
    jit.flush();
    LOG("turn off jit");
end

local main = {};

_NeedPause = function()
  main:_NeedPause();
end




if _KRATOSEDITOR then
  main._Agent = main;
else  
  g_callbackhandle = main;
  gMain = main
  
  --初始化回调
  main.servicecallbacks = {}
  main.callbackindex = 1;
  setmetatable(main.servicecallbacks, {__mode = "v"}) --弱引用 
  --以下为固定接口
  function main:RegisterCallback(func)
    local index = self.callbackindex;
    self.callbackindex = self.callbackindex + 1;
    self.servicecallbacks[index] = func;
    return self._Agent, index;
  end

  function main:CallbackFunction(index, ...)
    --_COROUTINES_ON();
    local func = self.servicecallbacks[index];
    local res = true;
    if func then
      res = func(...);
    end
    --_COROUTINES_OFF();
    return res;
  end

  
  function main:Exec(command)
    local f = load("return gMain:" .. command)
    if f == nil then
        return false
    end
    return f()
  end
end

function main:Timespan()
  local now = venuscore.ITimerSystem:GetTimevalue();
  local def = now - self.begintime;
  self.begintime = now;

  self.cumtime = self.cumtime + def;
  self.fps = self.fps + 1;
  if self.cumtime > 5 then
    local fps = self.fps / self.cumtime;
    self.fps = 0;
    self.cumtime = 0;
    LOG("logic fps "..fps);
  end
  --防止间隔过长导致效果突变太大效果不自然
  def = def < 0.1 and def or 0.03;
  return def;
end

function main:OnResizeView(x,y,w,h)
end

--加载换脸配置表
function main:FacecuteLoadResource(path)
  --self.facecuteScene:Begin("Sticker");
  if not venuscore.IFileSystem:isFileExist(path) then
    ERROR("FacecuteLoadResource "..tostring(path).." not exist");
    return false ;
  end

  local res = SceneLoader:LoadAsSticker(path)

  --防止时间间隔过长导致第一次update曲线取值跳跃太大
  self.begintime = venuscore.ITimerSystem:GetTimevalue();
  --self.facecuteScene:End("Sticker");
  collectgarbage();

  return self.isloaded;
end

function main:FacecuteUnloadResource()
  SceneLoader:ReleaseSticker();
  return true;
end

function main:CreateCR(near, far, pos, lookat, up)
  local maincamera = apollonode.CameraNode();--新建摄像机
  --maincamera:CreatePerspectiveProjection(near, far);
  maincamera:SetName("MainCamera")
  maincamera:CreateRealCameraProjection(near, far);--设置摄像机
  maincamera:LookAt(pos, lookat, up);
  maincamera:Recalculate();--手动更新矩阵
  maincamera:SetClearColor(mathfunction.Color(0.0,0.0,1.0,1));
  maincamera:Activate();--激活主摄像机
  return maincamera;
end

function main:Initialize()

  venuscore.ILogSystem:ImmediateMode(true)
  
  self.begintime = venuscore.ITimerSystem:GetTimevalue();
  self.cumtime = 0;
  self.fps = 0;  

    emptyimage:Initialize();
    pbrlighting:Initialize();--对PBR材质中的贴图的slot进行初始化
    scenetimerender:Initialize();
  

    SceneLoader:Initialize();
    --创建一个场景
    self.cameraScene = apolloengine.SceneManager:GetOrCreateScene(apolloDefine.default_scene_name);


    -- self.mainCamera = self:_CreateCamera("Default", mathfunction.Color(1.0,0.0,0.0,1));
    self.mainCamera = self:CreateCR(0.01, 20, mathfunction.vector3(0,0,0), mathfunction.vector3(0,0,-1), mathfunction.vector3(0,1,0));

    renderqueue:Initialize(self.mainCamera);
    renderqueue:Activate(LAYER_LAST);

    self:FacecuteLoadResource("/Users/zhangdongjiu/Workspace/ar_lidar/algo_video_facecute/scene.json");

    
    self.mainCamera:SetRenderWindow(apolloengine.IGraphicSystem:GetMainWindow());

    --创建一个四边形
    self:_CreateQuad("Default", 3);

    apolloengine.Framework:AddSynchronizeUpdateCallback(self._Agent, "SyncUpdate"); --添加同步更新


    return true;
end

function main:Exit()
    apolloengine.Framework:RemoveSynchronizeUpdateCallback(self._Agent, "SyncUpdate");
    apolloengine.SceneManager:DeleteScene(apolloDefine.default_scene_name);
      SceneLoader:ReleaseSticker();
    WARNING("*************************************************************main_test:Exit");
    -- return true;
end

function main:AttachRenderTarget(fbo, texture)
    LOG(string.format("[%s::AttachRenderTarget]platform android, fbo: %d", TAG, fbo));
    self.rendertarget = apolloengine.RenderTargetEntity(); --创建一个FBO
    self.rendertarget:PushMetadata(
    --设置FBO格式
            apolloengine.RenderTargetResourceMetadata(
                    apolloengine.RenderTargetEntity.RT_RENDER_TARGET_2D,
                    apolloengine.Framework:GetResolution(),
            --分辨率
                    fbo
            )
    );
    self.outputtexture = self.rendertarget:MakeTextureAttachment(apolloengine.RenderTargetEntity.TA_COLOR_0); --增加color0纹理
    self.outputtexture:PushMetadata(
        apolloengine.TextureResourceMetadata(apolloengine.Framework:GetResolution(), texture)   --创建纹理
    );
    self.rendertarget:CreateResource();
    -- self.mainCamera:AttachRenderTarget(self.rendertarget);
    renderqueue:SetOutputRenderTarget(self.rendertarget, self.outputtexture)
    return true;
end

function main:SyncUpdate()
    --_COROUTINES_ON();
     local def = self:Timespan();
    self.def = def;
    self:_Running();
    --_COROUTINES_OFF();
end

function main:Update()
    self:_Running();
end

function main:_Running()
      local def = self.def;
      SceneLoader:UpdateSticker(def);
   -- self:_CreateQuad("Default", 3);
    --local delts = self:Timespan()
    WARNING("--> main_test::_Running");

    self.cameraScene:Update(0.1);

end




function main:_CreateCamera(layer,clearcolor)
    local camera = self.cameraScene:CreateNode(apolloengine.Node.CT_NODE);
    local cameraComponent = camera:CreateComponent(apolloengine.Node.CT_CAMERA);

    local near = 0.1;
    local far = 20;
    local pos = mathfunction.vector3(0,0,1);
    local resolution = mathfunction.vector2(320,420);
    local lookat = mathfunction.vector3(0,0,0);
    local up = mathfunction.vector3(0,1,0);

    cameraComponent:AddLayerMask(layer);
    --cameraComponent:FixedResolution(resolution)
    cameraComponent:CreatePerspectiveProjection(near,far);
    cameraComponent:LookAt(pos,lookat,up);
    cameraComponent:Recalculate();
    cameraComponent:Activate();
    cameraComponent:SetClearColor(clearcolor);

    return camera;
end


function main:_CreateQuad(layer,renderOrder)
    local quad = self.cameraScene:CreateNode(apolloengine.Node.CT_NODE);
    local trans = quad:CreateComponent(apolloengine.Node.CT_TRANSFORM);
    local render = quad:CreateComponent(apolloengine.Node.CT_RENDER);
    quad:SetLayer(layer);

    render:PushMetadata(
        --这里的quad shader有修改过
        apolloengine.RenderObjectMaterialMetadata(apolloengine.PathMetadata("comm:documents/shaders/opaque/unlit.material"))
    );

    render:PushMetadata(
        apolloengine.RenderObjectMeshFileMetadate("comm:documents/basicobjects/quad/data/plane001.mesh")
    );
    render:CreateResource();

    render:SetRenderOrder(renderOrder);

    self.rgbTextureEntity = apolloengine.TextureEntity();
    self.rgbTextureEntity:PushMetadata(
          apolloengine.TextureFileMetadata(
                  apolloengine.TextureEntity.TU_WRITE,
                  apolloengine.TextureEntity.PF_R8G8B8,
                  1, true,
                  apolloengine.TextureEntity.TW_CLAMP_TO_EDGE,
                  apolloengine.TextureEntity.TW_CLAMP_TO_EDGE,
                  apolloengine.TextureEntity.TF_LINEAR,
                  apolloengine.TextureEntity.TF_LINEAR_MIPMAP_LINEAR,
                  "comm:documents/texture/img.jpg"));
    self.rgbTextureEntity:SetKeepSource(true);
    self.rgbTextureEntity:CreateResource();
    self._MainTex = apolloengine.IMaterialSystem:NewParameterSlot(apolloengine.ShaderEntity.UNIFORM,"_MainTex");
    render:SetParameter(self._MainTex, self.rgbTextureEntity);

end



return main
