require "utility"
local apolloengine = require "apolloengine"
local mathfunction = require "mathfunction"
local videodecet = require "videodecet"
local venuscore = require "venuscore"
local overlay = {}

overlay.renderObject = nil;
overlay.material = nil;
overlay.queue = 100;
overlay.blendtex = nil;

function overlay:Initialize(host, size)
  local preTexPath = "comm:documents/texture/posteffect/lutpv.png";
  self.blendtex = apolloengine.TextureEntity();
  self.blendtex:PushMetadata(apolloengine.TextureFileMetadata(
        apolloengine.TextureEntity.TU_STATIC,
        apolloengine.TextureEntity.PF_AUTO,1, false,
        apolloengine.TextureEntity.TW_CLAMP_TO_EDGE,
        apolloengine.TextureEntity.TW_CLAMP_TO_EDGE,
        apolloengine.TextureEntity.TF_NEAREST,
        apolloengine.TextureEntity.TF_NEAREST,
        preTexPath));
  self.blendtex:SetJobType(venuscore.IJob.JT_SYNCHRONOUS);
  self.blendtex:CreateResource();
  self.TEXTURE_BLEND = apolloengine.IMaterialSystem:NewParameterSlot(apolloengine.ShaderEntity.UNIFORM,"TEXTURE_BLEND");
  --self.renderObject = host:CreateRenderObject("comm:documents/material/blend_overlay.material");
  self.renderObject = host:CreateRenderObject();
  self.material = host:CreateMaterial("comm:documents/material/blend_overlay.material");

  host:RegisterScriptParameter(self,"blendtex");
  return self.queue;
end

function overlay:Resizeview(size)

end

function overlay:Process(context, Original, Scene, Output)
  --Output:PushRenderTarget();
  --Output:ClearBuffer(apolloengine.RenderTargetEntity.CF_COLOR);
  context:BeginRenderPass(Output, apolloengine.RenderTargetEntity.CF_COLOR);
  self.material:SetParameter(
          apolloengine.ShaderEntity.TEXTURE_DIFFUSE,
          Scene:GetAttachment(apolloengine.RenderTargetEntity.TA_COLOR_0));
        
  self:UpdateParameters();
  
  --self.renderObject:Draw(pipeline);
  context:Draw(self.renderObject, self.material);
  context:EndRenderPass();
end

function overlay:UpdateParameters()
  if self.blendtex ~= nil then
    self.material:SetParameter(self.TEXTURE_BLEND, self.blendtex);
  end
end

return overlay;