
local ae = require "apolloengine"
local mf = require "mathfunction"

local cclens = {}

function cclens:Initialize(host, size)

  self.renderObject = 0;
  self.material = 0;
  self.Queue = 100
 
  --self.SCALE_PARAM_SLOT = ae.IMaterialSystem:NewParameterSlot(ae.ShaderEntity.UNIFORM,"Scale")
        
  self.Size = mf.vector1(0.1);
  self.Convergence = mf.vector1(100.0);
  self.Center = mf.vector2(0.5, 0.5);
  self.fboSize = mf.vector2(size:x(), size:y());

  self.POST_EFFECT_ALPHA = ae.IMaterialSystem:NewParameterSlot(
    ae.ShaderEntity.UNIFORM,
    "POST_EFFECT_ALPHA");
  
  self.renderObject = host:CreateRenderObject();
  self.material = host:CreateMaterial("comm:documents/shaders/posteffect/cclens.material");
  self.material:SetParameter(self.POST_EFFECT_ALPHA, mf.vector1(1.0));
  
  host:RegisterScriptParameter(self, "Center");
  host:RegisterScriptParameter(self, "Size"); --[0,500]
  host:RegisterScriptParameter(self, "Convergence"); --[-200,100]
  
  return self.Queue
end

function cclens:Resizeview(size)
  self.fboSize = mf.vector2(size:x(), size:y());
end

function cclens:Process(context, Original, Scene, Output)
  --Output:PushRenderTarget()
  --Output:ClearBuffer(ae.RenderTargetEntity.CF_COLOR)
  context:BeginRenderPass(Output, ae.RenderTargetEntity.CF_COLOR);

  --local materials = self.renderObject.MaterialEntities;
  --local material = materials[1];
    
  --material:SetParameter(
  --        "_MainTex",
  --        Scene:GetAttachment(ae.RenderTargetEntity.TA_COLOR_0));

  self.material:SetParameter("_MainTex",
          Scene:GetAttachment(ae.RenderTargetEntity.TA_COLOR_0));
  
  local radius = math.max(self.Size:x(), 0.00001);
  --material:SetParameter("_Radius", mf.vector2(radius, radius * self.fboSize:x() / self.fboSize:y()));
  self.material:SetParameter("_Radius", mf.vector2(radius, radius * self.fboSize:x() / self.fboSize:y()));

  
  self.material:SetParameter("_Convergence", self.Convergence * (-0.01) );
  self.material:SetParameter("_DistortCenter", self.Center );
  
  --self.renderObject:Draw(pipeline)
  context:Draw(self.renderObject, self.material);
  context:EndRenderPass();
end


return cclens;