


local apolloengine = require "apolloengine"
local mathfunction = require "mathfunction"
local venuscore = require "venuscore"

local imagematting = {}
imagematting.Do = 0;
imagematting.Queue = 310;

imagematting.imageMatRenderObj = 0;
imagematting.imageMatMaterial = 0;


function imagematting:Initialize(host, size)
  
  self.RGBMat = mathfunction.vector3(1.0,1.0,0.0);
  
  self.RGB_MAT_SLT = apolloengine.IMaterialSystem:NewParameterSlot(
    apolloengine.ShaderEntity.UNIFORM,
    "RGB_MAT");  
    
  local alphachangePath = venuscore.IFileSystem:PathAssembly("comm:documents/material/imagematting.material"); 

  self.imageMatMaterial = host:CreateMaterial(alphachangePath);
  self.imageMatRenderObj = host:CreateRenderObject();

  self.imageMatMaterial:SetParameter(self.RGB_MAT_SLT, self.RGBMat);

  host:RegisterScriptParameter(self,"RGBMat");

  return self.Queue;
  
end


function imagematting:Resizeview(size)

end


function imagematting:Process(context, Original, Scene, Output)
  
  self:_UpdateParameters();
  
  context:BeginRenderPass(Output, apolloengine.RenderTargetEntity.CF_COLOR_DEPTH_STENCIL);
  self.imageMatMaterial:SetParameter(
    apolloengine.ShaderEntity.TEXTURE_DIFFUSE,
    Scene:GetAttachment( apolloengine.RenderTargetEntity.TA_COLOR_0));
  context:Draw(self.imageMatRenderObj, self.imageMatMaterial);
  context:EndRenderPass();
    
end

function imagematting:_UpdateParameters()
  self.imageMatMaterial:SetParameter(self.RGB_MAT_SLT,  self.RGBMat);
end

return imagematting;
