local Venuscore = require "venuscore"
local apolloengine = require "apolloengine"
local mathfunction = require "mathfunction"

local FluidParticleControl = Venuscore.VenusBehavior:extend("FluidParticleControl");

function FluidParticleControl:new()
  --self.FluidCom = nil;
  --self.ParticleTransCom = nil;
  self.flag = -1;
  --self.flagDir = 1;
  --self.moveV = 0.02;
  self.rotSpeed = -0.01;
  self.count = 0.0;
end


function FluidParticleControl:_OnAwake()
  --self.TransCom = self.Node:GetComponent(apolloengine.Node.CT_TRANSFORM);
end

function FluidParticleControl:_OnUpdate(def)
	
  --local pos = self.ParticleTransCom:GetLocalPosition();
  --pos.mx = pos.mx + self.flag * 0.01;
  --
  --if pos.mx > 1.6 or pos.mx< -1.26 then
  --  self.flag = -self.flag;
  --end
  --
  --self.ParticleTransCom:SetLocalPosition(pos);
  if self.trans then
    local pos = self.trans:GetLocalPosition();
    pos.mx = pos.mx + self.flag * 0.01;
    --self.count  = self.count + self.flag * 0.01;
    if pos.mx > 0.45 or pos.mx< -0.45 then
      self.flag = -self.flag;
    end

    self.trans:SetLocalPosition(pos);

    --local rot = self.trans.LocalEularAngle;
    --rot.mz = rot.mz + 0.004;
  end

  --if self.fluid then
  --  local dir = self.fluid:GetImpluseDir();
  --  dir.mx = dir.mx * math.cos(self.rotSpeed) + dir.mz * math.sin(self.rotSpeed);
  --  dir.mz = -dir.mx * math.sin(self.rotSpeed) + dir.mz * math.cos(self.rotSpeed);
  --
  --  self.fluid:SetImpluseDir(dir);
  --end

end

function FluidParticleControl:GetRotSpeed()
  return self.rotSpeed;
end

function FluidParticleControl:SetRotSpeed(value)
  self.rotSpeed = value;
end

function FluidParticleControl:GetFluid()
  return self.fluid;
end

function FluidParticleControl:SetFluid(fluid)
  self.fluid = fluid;
end

function FluidParticleControl:GetTrans()
  return self.trans;
end

function FluidParticleControl:SetTrans(trans)
  self.trans = trans;
end

FluidParticleControl:MemberRegister("trans",
        Venuscore.ScriptTypes.ReferenceType(
                apolloengine.TransformComponent:RTTI(),
                FluidParticleControl.GetTrans,
                FluidParticleControl.SetTrans
        ));

FluidParticleControl:MemberRegister("fluid",
    Venuscore.ScriptTypes.ReferenceType(
    apolloengine.FluidComponent:RTTI(),
            FluidParticleControl.GetFluid,
            FluidParticleControl.SetFluid
));


FluidParticleControl:MemberRegister("rotSpeed",
        Venuscore.ScriptTypes.FloatType(
                -0.2, 0.2,
                FluidParticleControl.GetRotSpeed,
                FluidParticleControl.SetRotSpeed
        ));

return FluidParticleControl;