local apolloengine = require "apolloengine"
local mathfunction = require "mathfunction"

local bulgedistortion = {}
bulgedistortion.BdMat = 0;

bulgedistortion.Queue = 117;

function bulgedistortion:_SetParam(size)  -- fortest
  self.height= size:y();
  self.width=size:x();
  self.Bd:SetParameter(self.ASPECT_RATIO, mathfunction.vector1( self.width/self.height ) );
end


function bulgedistortion:Initialize(host, size)
    --<!--  set the offsets parameters in vertex shader -->
  self.RADIUS = apolloengine.IMaterialSystem:NewParameterSlot(
      apolloengine.ShaderEntity.UNIFORM,"RADIUS"); 
  self.SCALE = apolloengine.IMaterialSystem:NewParameterSlot(
      apolloengine.ShaderEntity.UNIFORM,"SCALE"); 
  self.ASPECT_RATIO = apolloengine.IMaterialSystem:NewParameterSlot(
      apolloengine.ShaderEntity.UNIFORM,"ASPECT_RATIO"); 
  self.BdMat = host:CreateMaterial("comm:documents/filter/material/bulgedistortion.material" );
  self.BdRO = host:CreateRenderObject()
  self:_SetParam(size);
  self.BdMat:SetParameter(self.RADIUS, mathfunction.vector1( 0.5 ) );
  self.BdMat:SetParameter(self.SCALE, mathfunction.vector1( 0.5 ) );
  return self.Queue;
end

function bulgedistortion:Resizeview(size)
   self:_SetParam(size);
end

function bulgedistortion:Process(context, Original, Scene, Output)
  context:BeginRenderPass(Output, apolloengine.RenderTargetEntity.CF_COLOR);
  self.BdMat:SetParameter(
		apolloengine.ShaderEntity.TEXTURE_DIFFUSE,
		Scene:GetAttachment( apolloengine.RenderTargetEntity.TA_COLOR_0 ) );
  context:Draw(self.BdRO, self.BdMat);
  context:EndRenderPass();
end

return bulgedistortion;