local venusjson = require "venusjson"
local venuscore = require "venuscore"
local object = require "classic"
local torch = require "torch"
local Operator = require "torchutility.operator"
local AutoTensor = require "torchutility.autotensor"

local Flat = Operator:extend();

function Flat:new(...)
    Flat.super.new(self,...);
    
end

function Flat:Caculate( param1 )
    return param1:view(-1);
end

function Flat:Derivative(...)
    if self:HasParamForD(1,...) then
        local size = self.paramcache[1]:R():size()[1]*self.paramcache[1]:R():size()[2];
        local j = torch.Tensor(size):fill(1);
        
        return torch.diag( j);
    else
        assert(false);
    end
end



return Flat;