--debug和profiler不能同时开启，debug优先
_DEBUG = false;
_PROFILER = false;
if _DEBUG and (_PLATFORM_WINDOWS or  _PLATFORM_MACOS) then
  local debuger = require "mobdebug/mobdebug";
  debuger.start();
  _COROUTINES_ON = debuger.on;
  _COROUTINES_OFF = debuger.off;
else
  _COROUTINES_ON = function() end;
  _COROUTINES_OFF = function() end;
end

if _PROFILER and _PLATFORM_WINDOWS and not _DEBUG then
  local count = 0
  local profiler = require "profiler"
  _PROFILER_START = function () profiler:start(); end
  _PROFILER_END = function () profiler:stop(); profiler:writeReport('profiler.txt'); end
  _PROFILER_UPDATE = function ()
      count = count + 1;
      if count == 6000 then
        profiler:stop();
        profiler:writeReport('profiler.txt');
      end
    end
else
  _PROFILER_START = function() end;
  _PROFILER_END = function() end;
  _PROFILER_UPDATE = function() end;
end